local _hts_PlayerInventory_init = PlayerInventory.init

function PlayerInventory:init(...)
	_hts_PlayerInventory_init(self, ...)
	self._gunshield_unit = nil
	self.gun_shield_enabler = false
	self.primary_weapon_is_active = false
end

local _hts_PlayerInventory_place_selection = PlayerInventory._place_selection

function PlayerInventory:_place_selection(selection_index, is_equip)
	_hts_PlayerInventory_place_selection(self, selection_index, is_equip)
	if not self:is_this_able_to_gunshield() then
		return
	end
	if is_equip then
		self:give_gunshield()
	else
		self:hide_gunshield()
	end
end

function PlayerInventory:get_gunshield_unit()
	return self._gunshield_unit
end

function PlayerInventory:check_gunshield_unit()
	return self._gunshield_unit
end

function PlayerInventory:give_gunshield()
	if not self:is_this_able_to_gunshield() then
		return
	end
	self:hide_gunshield()
	local selection = self._available_selections[self._equipped_selection]
	if not selection then
		return
	end
	local equipped_primary = managers.blackmarket:equipped_primary()
	local weapon_unit = selection.unit
	local factory_id = weapon_unit:base()._factory_id
	local weapon_id = managers.weapon_factory:get_weapon_id_by_factory_id(factory_id)
	local equipped_primary = managers.blackmarket:equipped_primary()
	local equipped_secondary = managers.blackmarket:equipped_secondary()
	if equipped_primary.weapon_id == weapon_id then
		self.primary_weapon_is_active = true
	else
		self.primary_weapon_is_active = false
	end
	--// Just in case //
	--elseif equipped_secondary.weapon_id == weapon_id 
	--	self.primary_weapon_is_active = false
	--else
	--	return
	--end
		--local equipped_primary = managers.blackmarket:equipped_primary()
		--local equipped_secondary = managers.blackmarket:equipped_secondary()
	if self.primary_weapon_is_active then
		if self:gun_shield_check() then
			if tweak_data.weapon[equipped_primary.weapon_id].category ~= "assault_rifle"  then
				return
			else
				-- check here	
			end
		else
			self:hide_gunshield()
			return
		end
	elseif not self.primary_weapon_is_active then
		if self:secondary_gun_shield_check() then
				if tweak_data.weapon[equipped_secondary.weapon_id].category ~= "smg" then
					return
				else
					-- check here	
				end
		end
	else 
		self:hide_gunshield()
		return
	end
	if not self:gun_shield_check() and not self:secondary_gun_shield_check() then
		--log('gun_shield_enabler:'..tostring(self.gun_shield_enabler))
		return
	end
	if equipped_secondary.weapon_id == weapon_id and not self:secondary_gun_shield_check() then
		self:hide_gunshield()
		return
	end
	if equipped_primary.weapon_id == weapon_id and not self:gun_shield_check() then
		self:hide_gunshield()
		return
	end
	self.gun_shield_enabler = true
	local weap_align_data = selection.use_data["equip"]
	local align_place = self._align_places[weap_align_data.align_place]
	self._gunshield_unit = true
end

function PlayerInventory:hide_gunshield()
	if not self:is_this_able_to_gunshield() then
		return
	end
	if self._gunshield_unit then
		self._gunshield_unit = false
	end
end

function PlayerInventory:is_this_able_to_gunshield()
	local peer = managers.network:session():peer_by_unit(self._unit)
	if peer and peer == managers.network:session():local_peer() then
		return true
	end
	return false
end

function PlayerInventory:gun_shield_enabled()
	return self.gun_shield_enabler
end

function PlayerInventory:gun_shield_check()
local equipped_primary = managers.blackmarket:equipped_primary()
	if tweak_data.weapon[equipped_primary.weapon_id].category ~= "assault_rifle" then
		return false		
	else
			for index, value in ipairs(equipped_primary.blueprint) do
				if value == "wpn_fps_ass_scharlie_shield_siege" then
					return true
				end
			end
			return false
	end
end

function PlayerInventory:secondary_gun_shield_check()
	local equipped_secondary = managers.blackmarket:equipped_secondary()
	if  tweak_data.weapon[equipped_secondary.weapon_id].category ~= "smg" then
		return false
	else
			for index, value in ipairs(equipped_secondary.blueprint) do
				if value == "wpn_fps_ass_scharlie_shield_siege" then
					return true
				end
			end
			return false
	end	
end